



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux2.6内核--对块IO层操作的讨论</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux2.6内核--对块IO层操作的讨论</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 20:27:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>&nbsp; &nbsp; &nbsp; 当一个块被调入内存时（也就是说，在读入后或等待写出时），它要存储在缓冲区中。每个缓冲区与一个块对应，它相当于是磁盘块在内存中的表示。块包含一个或多个扇区，但大小不能超过一页，所以一页可以容纳一个或多个内存块。由于内核在处理数据时需要一些相关的控制信息（比如块属于哪个设备，块对应于哪个缓冲区），所以，每一个缓冲区都有一个对应的描述符。该描述符用 buffer_head 结构体表示，称作缓冲区头，在文件 &nbsp;&lt;linux/buffer_head.h&gt; 中定义，它包含了内核操作缓冲区的全部信息。</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 下面给出缓冲区头结构体和其中每一个域的说明：</strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>struct buffer_head {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;unsigned long b_state; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* buffer state bitmap (see above) */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;struct buffer_head *b_this_page;/* circular list of page's buffers */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;struct page *b_page; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* the page this bh is mapped to */<br />&nbsp;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;sector_t b_blocknr; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* start block number */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;size_t b_size; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* size of mapping */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;char *b_data; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* pointer to data within the page */<br />&nbsp;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;struct block_device *b_bdev;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;bh_end_io_t *b_end_io; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* I/O completion */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;void *b_private; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* reserved for b_end_io */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;struct list_head b_assoc_buffers; /* associated with another mapping */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;struct address_space *b_assoc_map; &nbsp; &nbsp; &nbsp;/* mapping this buffer is<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; associated with */<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;atomic_t b_count; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* users using this buffer_head */<br />&nbsp;};<br /></strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 缓冲区头的目的在于描述磁盘块和物理内存缓冲区之间的映射关系。这个结构体在内核中只是扮演一个描述符的角色，说明从缓冲区到块的映射关系。</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 在2.6内核以前，缓冲区头的作用比现在还要重要。因为缓冲区头作为内核中的 IO 操作单元，不仅仅描述了从磁盘块到物理内存的映射，而且还是所有块 IO 操作的容器。但是在2.6内核以后改变了这种策略，它使用一个新的结构 -- bio 来作为操作容器。</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; bio 结构体定义于 &lt;linux/bio.h&gt; 中，下面给出 bio 结构体和每个域的描述：</strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>struct bio {<br />&nbsp; &nbsp; &nbsp; &nbsp; sector_t &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; bi_sector; &nbsp; &nbsp; &nbsp; &nbsp; /* associated sector on disk */<br />&nbsp; &nbsp; &nbsp; &nbsp; struct bio &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; *bi_next; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* list of requests */<br />&nbsp; &nbsp; &nbsp; &nbsp; struct block_device &nbsp;*bi_bdev; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* associated block device */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned long &nbsp; &nbsp; &nbsp; &nbsp;bi_flags; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* status and command flags */<br />&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;unsigned long &nbsp; &nbsp; &nbsp; &nbsp;bi_rw; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* read or write? */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned short &nbsp; &nbsp; &nbsp; bi_vcnt; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* number of bio_vecs off */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned short &nbsp; &nbsp; &nbsp; bi_idx; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* current index in bi_io_vec */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned short &nbsp; &nbsp; &nbsp; bi_phys_segments; &nbsp;/* number of segments after coalescing */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned short &nbsp; &nbsp; &nbsp; bi_hw_segments; &nbsp; &nbsp;/* number of segments after remapping */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned int &nbsp; &nbsp; &nbsp; &nbsp; bi_size; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* I/O count */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned int &nbsp; &nbsp; &nbsp; &nbsp; bi_hw_front_size; &nbsp;/* size of the first mergeable segment */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned int &nbsp; &nbsp; &nbsp; &nbsp; bi_hw_back_size; &nbsp; /* size of the last mergeable segment */<br />&nbsp; &nbsp; &nbsp; &nbsp; unsigned int &nbsp; &nbsp; &nbsp; &nbsp; bi_max_vecs; &nbsp; &nbsp; &nbsp; /* maximum bio_vecs possible */<br />&nbsp; &nbsp; &nbsp; &nbsp; struct bio_vec &nbsp; &nbsp; &nbsp; *bi_io_vec; &nbsp; &nbsp; &nbsp; &nbsp;/* bio_vec list */<br />&nbsp; &nbsp; &nbsp; &nbsp; bio_end_io_t &nbsp; &nbsp; &nbsp; &nbsp; *bi_end_io; &nbsp; &nbsp; &nbsp; &nbsp;/* I/O completion method */<br />&nbsp; &nbsp; &nbsp; &nbsp; atomic_t &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; bi_cnt; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* usage counter */<br />&nbsp; &nbsp; &nbsp; &nbsp; void &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; *bi_private; &nbsp; &nbsp; &nbsp; /* owner-private method */<br />&nbsp; &nbsp; &nbsp; &nbsp; bio_destructor_t &nbsp; &nbsp; *bi_destructor; &nbsp; &nbsp;/* destructor method */<br />};<br /></strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 使用 bio 结构体的目的主要是代表正在现场执行的 IO 操作，所以该结构体中的主要域都是用来管理相关信息的，其中最重要的几个域是 bi_io_vecs , bi_vcnt 和 bi_idx 。下图显示了 bio 结构体及其他结构体之间的关系。</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130823153520421?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvRExVVEJydWNlWmhhbmc=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /><br /></strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 说明：每一个块 IO 请求都通过一个 bio 结构体表示。每个请求包含一个或多个块，这些块存储在 bio_vec 结构体数组中。这些结构体描述了每个片段在物理页中的实际位置，并且像向量一样被组织在一起。 IO 操作的第一个片段由 b_io_vec 结构体所指向，其他的片段在其后依次放置，共有 bi_vcnt个片段。当块 IO 层开始执行请求，需要使用各个片段时， bi_idx 域会不断更新，从而指向当前片段。</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 新老方法的比较：</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 缓冲区头和新的 bio 结构体之间存在显著差别。bio 结构体代表的是 IO操作，它可以包括内存中的一个或多个页；而另一方面，buffer_head 结构体代表的是一个缓冲区，它描述的仅仅是磁盘中的一个块，所以他可能会引起不必要的分割，将请求按块为单位划分，只能靠以后再重新组合。由于 bio 结构体是轻量级的，它描述的块可以不需要连续存储区，并且不需要分割 IO 操作。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwjlpy8.html">Linux-Memory小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxv018.html">C&num;中的volatile用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojxpv9.html">QT笔记之模态对话框及非模态对话框</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvrwmjq.html">C&plus;&plus;：this指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v254q.html">Crontab使用mailx的一点发现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrp249.html">swap chain- IDirect3DSwapChain9</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdx6l38.html">Java IO学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmyl4e9.html">java 按天创建文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkzg68.html">&lbrack;转载&rsqb;10 Best Tools For Websites And Apps Development Ever</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjld749.html">jQuery中ready与load事件的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjl3dk9.html">从字节理解Unicode（UTF8&sol;UTF16&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kyn209.html">hadoop-2&period;6&period;0源码编译问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpgwj39.html">Java线程的中断&lpar;Interruption&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwj7n79.html">1、话说linux内核</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnewxq.html">【洛谷P3901】数列找不同</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2r2xrq.html">如何创建&period;gitignore文件，忽略不必要提交的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2npn9.html">转载：configure生成的文件（1&period;5&period;3）《深入理解Nginx》（陶辉）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r52kkdq.html">English trip V1 - B 5&period;Is It Cold Outside&quest; 外面很冷？ Teacher&colon;Corrine Key&colon; weather</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g2lozq.html">MySQL免安装配置（亲测过，请放心借鉴）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjllv79.html">&lbrack;JavaScript&rsqb; 跳出循环方法总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydjxvgq.html">设计模式（二）The Observer Pattern 观察者模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde4ldj9.html">设计模式----代理模式（Proxy）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wlnjxq.html">&lbrack;Angular 2&rsqb; Adding a data model</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm32wk9.html">URL重写：RewriteCond指令与RewriteRule 指令格式&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm32209.html">lnux内核的malloc实现（Oracle的cache buffer影子）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96own3v9.html">Android Studio学习随笔-模拟耗时操作（sleep）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnm32j8.html">GIT学习（一）--&amp;gt&semi;Git产生的历史原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xkey68.html">firebug中console命令尝试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wl4mwq.html">webconfig的设置节点几个说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7142q.html">继承UIView的子控件添加点击事件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
